
Ruby - Feature #5053

ruby コマンドと libruby の食い違いチェック

07/19/2011 02:20 PM - metanest (Makoto Kishimoto)

Status: Rejected   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version:    

Description

ビルドした ruby を、インストールせずに、ビルドディレクトリで ./ruby のように実行すると、実行する ruby コマンドと、ロードされる libruby

でバージョンが食い違うことがありますが、その警告というのは（バイナリライブラリに互換性がないバージョンだったりしなければ）特に出たりしません

たまにはまることがあるので、main.c 中で RUBY_DESCRIPTION マクロと、グローバル変数 ruby_description

で一致するかどうかを調べて、違うようならウォーニングを出す、というパッチです

（※基本的なアイディアはえぐちさんによるものです）

History

#1 - 07/19/2011 07:23 PM - Anonymous

ビルドした ruby を、インストールせずに、ビルドディレクトリで ./ruby のように実行すると、実行する ruby コマンドと、ロードされる libruby

でバージョンが食い違うことがありますが、その警告というのは（バイナリライブラリに互換性がないバージョンだったりしなければ）特に出たりしません

たまにはまることがあるので、main.c 中で RUBY_DESCRIPTION マクロと、グローバル変数 ruby_description で一致するかどうかを調べて、違うようならウォーニングを出す、というパッチです

（※基本的なアイディアはえぐちさんによるものです）

 ./configure --program-suffix=hogehoge とかしても librubyは上書きされて消えてしまうので、

以前すごくイライラした記憶があるんですけど、そもそもlibrubyにバージョン番号か、

program suffixをつけるべきな気がしてるんですよね。

衝突を検知するよりも、衝突しない方向に頑張る方が前向きな気がするんですよ。はずしてるかなぁ

#2 - 07/19/2011 07:23 PM - Anonymous

ビルドした ruby を、インストールせずに、ビルドディレクトリで ./ruby のように実行すると、実行する ruby コマンドと、ロードされる libruby

でバージョンが食い違うことがありますが、その警告というのは（バイナリライブラリに互換性がないバージョンだったりしなければ）特に出たりしません

たまにはまることがあるので、main.c 中で RUBY_DESCRIPTION マクロと、グローバル変数 ruby_description で一致するかどうかを調べて、違うようならウォーニングを出す、というパッチです

（※基本的なアイディアはえぐちさんによるものです）

 ./configure --program-suffix=hogehoge とかしても librubyは上書きされて消えてしまうので、

以前すごくイライラした記憶があるんですけど、そもそもlibrubyにバージョン番号か、

program suffixをつけるべきな気がしてるんですよね。

衝突を検知するよりも、衝突しない方向に頑張る方が前向きな気がするんですよ。はずしてるかなぁ

#3 - 07/19/2011 09:23 PM - metanest (Makoto Kishimoto)

きしもとです

./configure --program-suffix=hogehoge とかしても librubyは上書きされて消えてしまうので、

以前すごくイライラした記憶があるんですけど、そもそもlibrubyにバージョン番号か、

program suffixをつけるべきな気がしてるんですよね。

衝突を検知するよりも、衝突しない方向に頑張る方が前向きな気がするんですよ。はずしてるかなぁ

 FreeBSD だと ruby18 と ruby19 という ports になってますが、1.8.?

では "libruby18.so" 、1.9.? では "libruby.so" という名前になるので

たまたま /usr/local/lib に共存できてたりしてます。

r23368 より前では、configure.in で RUBY_SO_NAME='$(RUBY_INSTALL_NAME)'

となっているので、program suffixが影響するわけですね。r23368 の変更は

[ruby-dev:38241] からの議論の結果によるもののようです。
#4 - 07/19/2011 09:23 PM - metanest (Makoto Kishimoto)

きしもとです

./configure --program-suffix=hogehoge とかしても librubyは上書きされて消えてしまうので、

以前すごくイライラした記憶があるんですけど、そもそもlibrubyにバージョン番号か、

program suffixをつけるべきな気がしてるんですよね。

衝突を検知するよりも、衝突しない方向に頑張る方が前向きな気がするんですよ。はずしてるかなぁ

 FreeBSD だと ruby18 と ruby19 という ports になってますが、1.8.?

では "libruby18.so" 、1.9.? では "libruby.so" という名前になるので

たまたま /usr/local/lib に共存できてたりしてます。

r23368 より前では、configure.in で RUBY_SO_NAME='$(RUBY_INSTALL_NAME)'

となっているので、program suffixが影響するわけですね。r23368 の変更は

[ruby-dev:38241] からの議論の結果によるもののようです。

#5 - 07/20/2011 10:13 AM - usa (Usaku NAKAMURA)

パッチがこれでいいかどうかは確認してませんが、このチェックを入れることには

賛成します。

個人的には警告でなくエラーでいいと思う。

回避の努力自体はもうそれなりに入ってるので、それはそれ、これはこれ、

ということで。

#6 - 07/20/2011 01:47 PM - metanest (Makoto Kishimoto)

コンパイルした時刻のunix timeを埋め込んで、とかいうのも考えましたが、

そうするとちょっとオーバーキルかな、と思いました

#7 - 07/20/2011 02:23 PM - taca (Takahiro Kambe)

In message redmine.journal-19373.20110720134723@ruby-lang.org

on Wed, 20 Jul 2011 13:47:24 +0900,

Makoto Kishimoto redmine@ruby-lang.org wrote:

Issue #5053 has been updated by Makoto Kishimoto.

コンパイルした時刻のunix timeを埋め込んで、とかいうのも考えましたが、

そうするとちょっとオーバーキルかな、と思いました

同じソースコードから作成される限り、コンパイルした日時に関わらず同じ

実行ファイルとなった方が嬉しいと思います。

 --

神戸 隆博 (かんべ たかひろ)  at 仕事場

#8 - 07/20/2011 02:23 PM - taca (Takahiro Kambe)

In message redmine.journal-19373.20110720134723@ruby-lang.org

on Wed, 20 Jul 2011 13:47:24 +0900,

Makoto Kishimoto redmine@ruby-lang.org wrote:

Issue #5053 has been updated by Makoto Kishimoto.

コンパイルした時刻のunix timeを埋め込んで、とかいうのも考えましたが、

そうするとちょっとオーバーキルかな、と思いました

同じソースコードから作成される限り、コンパイルした日時に関わらず同じ

実行ファイルとなった方が嬉しいと思います。

 --

神戸 隆博 (かんべ たかひろ)  at 仕事場

#9 - 07/20/2011 03:38 PM - metanest (Makoto Kishimoto)

同じソースでも違うバイナリになることも問題かと思いますが、一種の個体追跡

（CPUの個体IDのような）のようなことに使えるのも問題かなと思いました。

ソースコードのとバイナリの同一性を重視するのであれば、指定したファイルの

ハッシュ値とかになるでしょうかね？
#10 - 02/07/2012 03:37 PM - mrkn (Kenta Murata)

同じソースでもコンパイルオプションを変えれば異なるバイナリが生成される可能性は十分ありますから、ソースの同一性だけでは判定できない気がします。

#11 - 03/25/2012 05:15 PM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

- Assignee set to tarui (Masaya Tarui)

#12 - 06/24/2012 05:10 PM - metanest (Makoto Kishimoto)

- File No5053.pdf added

[ruby-dev:45708] コンペ向けの資料を添付

#13 - 07/01/2012 09:52 AM - mame (Yusuke Endoh)

資料受け取りました。

(よく読んでませんが) これ、まつもとさんの認可が必要な内容なんですかね。

なかださんか誰かが勝手にやってしまえばいいレベルの話な気も。

まあ一応聞いてみます。

#14 - 07/02/2012 11:22 PM - nobu (Nobuyoshi Nakada)

正直なところ何が嬉しいのかさっぱりだったので放っておいたのですが…。

バージョンが一致しないlibrubyがロードされると嬉しくないのは同感なのですが、このチェックによって ./ruby が実行できなくなるとそのストレスは解消するものなんでしょうか。

#15 - 07/21/2012 08:07 PM - nobu (Nobuyoshi Nakada)

- File 0001-revision-check.patch added

- Status changed from Assigned to Feedback

ちょっと前(r36277)に、Makefileにrunnableというターゲットを追加しました。

今のところLinuxとMac OS Xしか対応していませんが、--enable-load-relativeを指定しておくと./bin/rubyでビルドしたバイナリが実行できるはずです。

こういったものではまずいでしょうか。

一応、RUBY_REVISIONとconfig.hのチェックサムで一致しない場合にエラーになるようにするパッチも作ったは作ったので、置いておきます。

ちなみに、私は https://github.com/nobu/build-files/blob/master/ruby.rb のようなラッパーで実行しています。

#16 - 07/21/2012 08:33 PM - nobu (Nobuyoshi Nakada)

- File deleted (0001-revision-check.patch)

#17 - 07/21/2012 08:34 PM - nobu (Nobuyoshi Nakada)

- File 0001-revision-check.patch added

テスト用にconfigureオプションを消していたのを忘れてました。

#18 - 07/23/2012 10:23 PM - mame (Yusuke Endoh)

- Assignee changed from tarui (Masaya Tarui) to nobu (Nobuyoshi Nakada)

きしもとさん

これはなかださんに一任となりました。

まつもとさんの意見は以下の 2 点です。

fail early の観点で、よい実装方法があるなら取り込みたい

ただし RUBY_DESCRIPTION を使うのはよい実装方法と思わない

--

Yusuke Endoh mame@tsg.ne.jp

#19 - 11/20/2012 11:18 PM - mame (Yusuke Endoh)

- Status changed from Feedback to Assigned
なかださん、いかがお過ごしでしょうか

--

Yusuke Endoh mame@tsg.ne.jp

#20 - 11/20/2012 11:49 PM - mame (Yusuke Endoh)

- Status changed from Assigned to Rejected

2012年11月20日 23:30 Nobuyoshi Nakada nobu@ruby-lang.org:

(12/11/20 23:18), mame (Yusuke Endoh) wrote:

なかださん、いかがお過ごしでしょうか

 いい具合でゴキゲンですが、[ruby-dev:45898]でも書いたように解決の方針がそもそも明後日ではないかと思います。

 一任されたなかださんがその意見なら、このチケットは rejected でよろしいかと思います。

--

Yusuke Endoh mame@tsg.ne.jp

#21 - 11/20/2012 11:53 PM - nobu (Nobuyoshi Nakada)

(12/11/20 23:18), mame (Yusuke Endoh) wrote:

なかださん、いかがお過ごしでしょうか

 いい具合でゴキゲンですが、[ruby-dev:45898]でも書いたように解決の方針がそもそも明後日ではないかと思います。

--

--- 僕の前にBugはない。

--- 僕の後ろにBugはできる。

中田 伸悦

#22 - 12/12/2015 01:00 AM - naruse (Yui NARUSE)

- Status changed from Rejected to Closed

#23 - 12/12/2015 01:00 AM - naruse (Yui NARUSE)

- Status changed from Closed to Rejected

Files

patch-revisioncheck.txt 1.23 KB 07/19/2011 metanest (Makoto Kishimoto)

No5053.pdf 17.5 KB 06/24/2012 metanest (Makoto Kishimoto)

0001-revision-check.patch 4.97 KB 07/21/2012 nobu (Nobuyoshi Nakada)
